#!/usr/bin/env python3

import sys
from string import ascii_lowercase, ascii_uppercase

MAX1 = 100000
MAX2 = 1000000000

def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x

def parsek(l, k):
    l2 = l.split(' ')
    xs = [int(xi) for xi in l2]
    assert (l == ((' '.join(str(xi) for xi in xs)) + "\n"))
    return xs

def parseintkstr(l):
    l2 = l.split(' ')
    assert(l2[-1][-1] == '\n')
    l2[-1] = l2[-1][:-1] # remove newline
    a = (l)
    b = (' '.join(xi for xi in l2))
    assert (l == ((' '.join(xi for xi in l2)) + "\n"))
    n = int(l2[0])
    assert(1 <= n <= MAX)
    assert (n == len(l2) - 1)
    for x in l2[1:]:
        assert(0 < len(x) <= 20)
        for y in x:
            assert(y in ascii_lowercase or y in ascii_uppercase)
    return l2[1:]

ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)
for ncase in range(ncases):
    n_l = sys.stdin.readline()
    xs = parsek(n_l, 6)
    assert (len(xs) == 6)
    assert (1 <= xs[0] <= MAX1)
    assert (1 <= xs[1] <= MAX1)
    assert (1 <= xs[2] <= MAX1)
    assert (1 <= xs[3] <= MAX1)
    assert (1 <= xs[4] <= MAX2)
    assert (1 <= xs[5] <= MAX2)
    assert (xs[4] < xs[5])
    for i in range(xs[0]):
        lli = sys.stdin.readline()
        li = parse1(lli)
        assert (1 <= li <= MAX2)
    seen = set()
    for i in range(xs[1]):
        cci = sys.stdin.readline()
        ci = parse1(cci)
        assert (0 <= ci <= MAX2)
        assert (ci not in seen)
        seen.add(ci)

# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)
