#!/usr/bin/env python3

import sys

MAX = 1000000000

def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x

def parsek(l, k):
    l2 = l.split(' ')
    xs = [int(xi) for xi in l2]
    assert (l == ((' '.join(str(xi) for xi in xs)) + "\n"))
    return xs

ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)
for ncase in range(ncases):
    n_l = sys.stdin.readline()
    xs = parsek(n_l, 4)
    assert (len(xs) == 4)
    assert(xs[0] >= 0)
    assert(xs[0] <= MAX)
    assert(xs[1] >= 0)
    assert(xs[1] <= MAX)
    assert(xs[2] >= 1)
    assert(xs[2] <= MAX)
    assert(xs[3] >= 1)
    assert(xs[3] <= MAX)
    # there must exist a valid numbering
    assert(abs(xs[2] - xs[3]) <= max(xs[0], xs[1]))

# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)
