#!/usr/bin/env python3

"""validate input for ex_direwires"""

from collections import defaultdict
import sys

# yeah, sorry
sys.setrecursionlimit(1010)

MINN = 1
MAXN = 10**6
MINM = 1
MINT = 1
MAXT = 10**15


def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x


def parse3(l):
    l2 = l.split(' ')
    x0 = int(l2[0])
    x1 = int(l2[1])
    x2 = int(l2[2])
    assert (l == (str(x0) + " " + str(x1) + " " + str(x2) + "\n"))
    return x0, x1, x2


def parse2(l):
    l2 = l.split(' ')
    a = int(l2[0])
    b = int(l2[1])
    assert (l == (str(a) + " " + str(b) + "\n"))
    return a, b


ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)
for ncase in range(ncases):
    n_l = sys.stdin.readline()
    n, m, t = parse3(n_l)
    assert (MINN <= n <= MAXN)
    assert (MINM <= m <= n)
    assert (MINT <= n <= MAXT)
    seen=set()
    for i in range(m):
        p_ln = sys.stdin.readline()
        a, b = parse2(p_ln)
        assert(1 <= a <= n)
        assert(1 <= b <= n)
        assert(b not in seen)
        seen.add(b)
    assert(len(seen) == m)
# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)
