#!/usr/bin/env python3

import sys
from string import ascii_lowercase, ascii_uppercase

MAXM = 50000
MAXN = 10000
MAXD = 1000

def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x

def parsek(l, k):
    l2 = l.split(' ')
    xs = [int(xi) for xi in l2]
    assert (l == ((' '.join(str(xi) for xi in xs)) + "\n"))
    return xs

ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)
for ncase in range(ncases):
    n_l = sys.stdin.readline()
    ttt = parsek(n_l, 2)
    assert(len(ttt) == 2)
    M = ttt[0]
    N = ttt[1]
    assert(1 <= M <= MAXM)
    assert(1 <= N <= MAXN)
    seen = set()
    for i in range(N):
        cci = sys.stdin.readline()
        tt = parsek(cci, 2)
        assert(len(tt) == 2)
        w = tt[0]
        h = tt[1]
        assert (0 < w <= MAXD)
        assert (0 < h <= MAXD)
        assert (w*h not in seen)
        seen.add(w*h)

# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)
