#!/usr/bin/env python3

import sys

MAXP = 2000
MAXR = 400000
MIN = 3
MINCOST = 1
MAXCOST = 3000

def parse1(l):
    x = int(l)
    assert (l == (str(x) + "\n"))
    return x

def parsek(l, k):
    l2 = l.split(' ')
    xs = [int(xi) for xi in l2]
    assert (l == ((' '.join(str(xi) for xi in xs)) + "\n"))
    return xs

ncases_l = sys.stdin.readline()
ncases = parse1(ncases_l)
for ncase in range(ncases):
    n_l = sys.stdin.readline()
    xs = parsek(n_l, 2)
    assert (len(xs) == 2)
    p = xs[0]
    r = xs[1]
    assert (MIN <= p <= MAXP)
    assert (MIN <= r <= MAXR)
    seen = set()
    for i in range(r):
        n_l2 = sys.stdin.readline()
        ys = parsek(n_l2, 3)
        assert (len(ys) == 3)
        assert (MINCOST <= ys[2] <= MAXCOST)
        assert (1 <= ys[0] <= p)
        assert (1 <= ys[1] <= p)
        assert(ys[0] != ys[1])
        t = (min(ys[0], ys[1]), max(ys[0], ys[1]))
        assert(t not in seen)
        seen.add(t)


# check if EOF is reached
rest = sys.stdin.read()
assert(len(rest) == 0)
