#!/usr/bin/env python3

from random import choice, randint
from string import ascii_lowercase


def mk_name(l):
    s = ""
    for i in range(l):
        s += choice(ascii_lowercase)
    return s


def generate(b, t, s, do_big=False):
    # 1/1, same
    for l in [1, 2, 20] + [randint(1, 20) for x in range(3)]:
        p = mk_name(l)
        print("%d %d %d" % (b, t, s))
        print("1 %s" % p)
        print("1 %s" % p)
    # 1/1, different
    for l in [1, 2, 20] + [randint(1, 20) for x in range(3)]:
        p = mk_name(l)
        p2 = mk_name(l)
        print("%d %d %d" % (b, t, s))
        print("1 %s" % p)
        print("1 %s" % p2)
    if do_big:
        # 1000/1000, all different
        print("%d %d %d" % (b, t, s))
        print("1000 " + ' '.join(mk_name(randint(5, 20)) for x in range(1000)))
        print("1000 " + ' '.join(mk_name(randint(5, 20)) for x in range(1000)))
    # 1000/1, all different
    print("%d %d %d" % (b, t, s))
    print(("1000 " if do_big else "200 ") + ' '.join(mk_name(randint(5, 20 if do_big else 8)) for x in
        range(1000 if do_big else 200)))
    print("1 " + mk_name(randint(5, 20 if do_big else 8)))
    # 1/1000, all different
    print("%d %d %d" % (b, t, s))
    print("1 " + mk_name(randint(10, 20)))
    print(("1000 " if do_big else "200 ") + ' '.join(mk_name(randint(5, 20 if do_big else 8)) for x in
        range(1000 if do_big else 200)))
    # 1000/1, all same
    n = mk_name(randint(5, 20 if do_big else 8))
    print("%d %d %d" % (b, t, s))
    print(("1000 " if do_big else "200 ") + ' '.join(n for x in range(1000 if do_big else 200)))
    print("1 " + n)
    # 1/1000, all same
    n = mk_name(randint(5, 20 if do_big else 8))
    print("%d %d %d" % (b, t, s))
    print("1 " + n)
    print(("1000 " if do_big else "200 ") + ' '.join(n for x in range(1000 if do_big else 200)))
    # 1000/1, all same vs all same
    n = mk_name(randint(5, 20 if do_big else 8))
    n2 = mk_name(randint(5, 20 if do_big else 8))
    print("%d %d %d" % (b, t, s))
    print(("1000 " if do_big else "200 ") + ' '.join(n for x in range(1000 if do_big else 200)))
    print("1 " + n2)
    # 1/1000, all same vs all same
    n = mk_name(randint(5, 20 if do_big else 8))
    n2 = mk_name(randint(5, 20 if do_big else 8))
    print("%d %d %d" % (b, t, s))
    print("1 " + n)
    print(("1000 " if do_big else "200 ") + ' '.join(n2 for x in range(1000 if do_big else 200)))
    # 1000/1, all same vs all same
    n = mk_name(randint(5, 20 if do_big else 8))
    n2 = mk_name(randint(5, 20 if do_big else 8))
    print("%d %d %d" % (b, t, s))
    print(("1000 " if do_big else "200 ") + ' '.join(n2 for x in range(1000 if do_big else 200)))
    print("1 " + n)
    # 1/1000, all same vs all same
    n = mk_name(randint(5, 20 if do_big else 8))
    n2 = mk_name(randint(5, 20 if do_big else 8))
    print("%d %d %d" % (b, t, s))
    print("1 " + n2)
    print(("1000 " if do_big else "200 ") + ' '.join(n for x in range(1000 if do_big else 200)))
    
    # choice of set sizes
    for i in list(range(1, 5)) + [randint(11, 2000 if do_big else 200) for x in range(3)]:
        sii = set()
        for j in range(i):
            sii.add(mk_name(randint(1, 20)))
        lii = list(sii)
        print("%d %d %d" % (b, t, s))
        na = randint(1, 1000 if do_big else 200)
        la = [choice(lii) for x in range(na)]
        nb = randint(1, 1000 if do_big else 200)
        lb = [choice(lii) for x in range(nb)]
        print("%d %s" % (na, ' '.join(la)))
        print("%d %s" % (nb, ' '.join(lb)))


for b in range(3):
    for t in range(3):
        for s in range(3):
            generate(b, t, s)

for i in range(2):
    generate(0, randint(0, 1000), randint(0, 1000))
    generate(randint(0, 1000), 0, randint(0, 1000))
    generate(randint(0, 1000), randint(0, 1000), 0)
    generate(0, 0, randint(0, 1000))
    generate(randint(0, 1000), 0, 0)
    generate(0, randint(0, 1000), 0)
    generate(0, 0, 0)

for i in range(4):
    b = randint(0, 1000)
    t = randint(0, 1000)
    s = randint(0, 1000)
    generate(b, t, s, True)
    # do a large 1000/1000, all different
    print("%d %d %d" % (b, t, s))
    print("1000 " + ' '.join(mk_name(20) for x in range(1000)))
    print("1000 " + ' '.join(mk_name(20) for x in range(1000)))
    # 1000/1000, all same
    n = mk_name(randint(10, 20))
    print("%d %d %d" % (b, t, s))
    print("1000 " + ' '.join(n for x in range(1000)))
    print("1000 " + ' '.join(n for x in range(1000)))
    # 1000/1000, all same vs all same
    n = mk_name(randint(10, 20))
    n2 = mk_name(randint(10, 20))
    print("%d %d %d" % (b, t, s))
    print("1000 " + ' '.join(n for x in range(1000)))
    print("1000 " + ' '.join(n2 for x in range(1000)))

