// C implementation without an unordered map, using a naive table instead

#include<stdio.h>
#include<string.h>
#include<limits.h>

#define MAX 1002

#define min(a, b) ((a) > (b) ? (b) : (a))

char N[2*MAX][32];
int S[2][MAX];
int G[MAX][MAX];
int ns[2];
int b, t, s;
int idx;

int calc(int i, int j) {
  if (i < 0 || j < 0) {
    return INT_MAX-MAX;
  }
  if (G[i][j] < INT_MAX-MAX) {
    return G[i][j];
  }
  return G[i][j] = min(
      t + calc(i-1, j),
      min(
        b + calc(i, j-1),
        (S[0][i] == S[1][j] ? 0 : s) + calc(i-1, j-1)));
}

int main() {
  int ncases;
  scanf("%d", &ncases);
  for (int ncase = 0; ncase < ncases; ncase++) {
    scanf("%d%d%d", &b, &t, &s);
    idx = 0;
    for (int s = 0; s < 2; s++) {
      scanf("%d", &(ns[s]));
      S[s][0] = 0; // sentinel
      for (int i = 0; i < ns[s]; i++) {
        char buf[32];
        scanf("%s", buf);
        int pos = -1;
        for (int p = 0; p < idx; p++) {
          if (!strcmp(buf, N[p])) {
            pos = p;
            break;
          }
        }
        if (pos == -1) {
          strcpy(N[idx], buf);
          pos = idx++;
        }
        S[s][i+1] = pos;
      }
    }
    for (int i = 0; i <= ns[0]; i++)
      for (int j = 0; j <= ns[1]; j++)
        G[i][j] = INT_MAX-MAX;
    G[0][0] = 0;
    int guilt = calc(ns[0], ns[1]);
    printf("%d\n", guilt);
  }
  return 0;
}

