#include<cstdio>
#include<iostream>
#include<unordered_map>
#include<climits>

#define MAX 1002

using namespace std;

unordered_map<string, int> N;
int G[MAX][MAX];
int S[2][MAX];
int ns[2];
int idx;
int b, t, s;

int calc(int i, int j) {
  if (i < 0 || j < 0) {
    return INT_MAX-MAX;
  }
  if (G[i][j] < INT_MAX-MAX) {
    return G[i][j];
  }
  return G[i][j] = min(
      t + calc(i-1, j),
      min(
        b + calc(i, j-1),
        (S[0][i] == S[1][j] ? 0 : s) + calc(i-1, j-1)));
}

int main() {
  int ncases;
  scanf("%d", &ncases);
  for (int ncase = 0; ncase < ncases; ncase++) {
    idx = 0;
    scanf("%d%d%d", &b, &t, &s);
    N.clear();
    for (int s = 0; s < 2; s++) {
      S[s][0] = 0; // sentinel
      scanf("%d", &(ns[s]));
      for (int i = 0; i < ns[s]; i++) {
        string name;
        cin >> name;
        auto nx = N.find(name);
        int nid;
        if (nx == N.end()) {
          nid = idx;
          N.insert(make_pair(name, idx++));
        } else {
          nid = nx->second;
        }
        S[s][i+1] = nid;
      }
    }
    for (int i = 0; i <= ns[0]; i++)
      for (int j = 0; j <= ns[1]; j++)
        G[i][j] = INT_MAX-MAX;
    G[0][0] = 0;
    int guilt = calc(ns[0], ns[1]);
    printf("%d\n", guilt);
  }
  return 0;
}

